getwd()

install.packages("ggpubr")
library(ggpubr)
install.packages("ggthemes")
library(ggthemes)
install.packages("gmodels")
library(gmodels)
install.packages("export")
library(export)
install.packages("scatterplot3d")
library(scatterplot3d)
library(ggplot2)
library(grid)
library(futile.logger)
library(RColorBrewer)
library(tidyverse)
library(hrbrthemes)



#FPKMֵ
data <- read.table("FPKM.txt", sep = "\t", header = T, row.names = 1)
dim(data)
head(data)

#################################
#
sample_cor <- cor(data)
sample_cor2 <- round(sample_cor, digits = 2)
library(pheatmap)
pheatmap(sample_cor2)

colnames(data)
data1 <- data[,c(1:24)]
colnames(data1)

ExpNor1 <- as.data.frame(data1)
ExpNor1 <- ExpNor1[!(apply(ExpNor1,1,sum)==0),]

#gmodelsԴfast.prcompPCм㡣
pca.info <- fast.prcomp(data)
head(pca.info)
#ܿÿPCĽͱ
summary(pca.info)
#عϵ
head(pca.info$rotation)
#ֵĿ
head(pca.info$sdev)
#÷score
head(pca.info$x)
screeplot(pca.info,type="lines")

mycolor <- c(rep("#2156A6", 3), rep("#2B6339", 3), rep("#EC4D44", 3), rep("#822A89", 3),
             rep("#00A1E9", 3), rep("#27C97B", 3), rep("#F39020", 3), rep("#424248", 3))

pca_data <- data.frame(sample = rownames(pca.info$rotation),
                      Type = c(rep("P_EL23", 3), rep("P_EL31", 3), 
                               rep("P_EL35", 3), rep("P_EL38", 3),
                               rep("V_EL23", 3), rep("V_EL31", 3),
                               rep("V_EL35", 3), rep("V_EL38", 3)),
                      pca.info$rotation)
pca_data



PCA_fpkm <- ggscatter(pca_data, x = "PC2", y = "PC3", 
          color = "Type", shape = 16,
          ellipse.border.remove = TRUE, 
          #ellipse = TRUE,
          size = 4, alpha = 0.5,
          lable = "sample", repel = TRUE, 
          addEllipses = TRUE,
          #main = "PCA plot"
          ) + theme_base()

pdf(file = "PCA_fpkm_3.pdf")
grid.draw(PCA_fpkm)
dev.off()

library(scatterplot3d)

scatterplot3d(pca_data$PC1,pca_data$PC2, pca_data$PC3, 
              color = mycolor, 
              pch = 16, 
              cex.symbols=2.2,
              xlab = paste('PCA1'), ylab = paste('PCA2'), zlab = paste('PCA3'))

PCA_plot
ggsave("PCA.png", width = 7,height = 5)


pdf(file = "PCA_fpkm_pca_3D.pdf")
grid.draw(PCA_plot)
dev.off()
