###Project_name: WGCNA
###zhangguan
###20220212

#######################################
#step1:װWGCNA
#install.packages('BiocManager')
#BiocManager::install('WGCNA')
library(WGCNA)

#######################################
###step2:׼
#֮
gene <- read.delim('diff_expr_FPKM_2984.txt', row.names = 1, check.names = FALSE)
gene <- data.frame(gene)
dim(gene)
head(gene)
#ֵתΪnumericʽ
gene_1 <- sapply(gene, as.numeric)
gene_1
#˵ͱֵĻֻƽֵ 1 ϵ
gene <- subset(gene_1, rowSums(gene_1)/ncol(gene_1) >= 1)
dim(gene)
#ΪWGCNAԵǻо࣬һǵľhclustɣʱҪת
gene <- t(gene)
head(gene)
ngenes = ncol(gene)
ngenes
nsamples = nrow(gene)
#####################################################
###step3:ޱ˷ȷѦֵ
#power ֵѡ
powers = c(c(1:10), seq(from = 12, to=20, by=2))
powers
sft <- pickSoftThreshold(gene, powerVector = powers, verbose = 5)

#ָ power ֵɢͼ
par(mfrow = c(1, 2))
cex1 = 0.9
plot(sft$fitIndices[,1], -sign(sft$fitIndices[,3])*sft$fitIndices[,2], type = 'n', 
     xlab = 'Soft Threshold (power)', ylab = 'Scale Free Topology Model Fit,signed R^2', 
     main = paste('Scale independence'))
text(sft$fitIndices[,1], -sign(sft$fitIndices[,3])*sft$fitIndices[,2],
     labels = powers, col = 'red')
abline(h = 0.90, col = 'red')

#ƽͨ power ֵɢͼ
plot(sft$fitIndices[,1], sft$fitIndices[,5],
     xlab = 'Soft Threshold (power)', ylab = 'Mean Connectivity', type = 'n',
     main = paste('Mean connectivity'))
text(sft$fitIndices[,1], sft$fitIndices[,5], labels = powers, col = 'red')

#鿴ֵ
sft

#######################################
###step4:û򹲱ƶȾ
#һƵ power ֵ
powers <- sft$powerEstimate
powers
# TOM 
adjacency <- adjacency(gene, power = powers)
tom_sim <- TOMsimilarity(adjacency)
rownames(tom_sim) <- rownames(adjacency)
colnames(tom_sim) <- colnames(adjacency)
tom_sim[1:6,1:6]
#write.table(tom_sim, 'TOMsimilarity.txt', sep = '\t', col.names = NA, quote = FALSE)

#######################################
###step5ģʶ
#TOM  = 1 C TOM ƶ
tom_dis  <- 1 - tom_sim

#ξʹֵķȨسɶ鷨ƽۺϾ
geneTree <- hclust(as.dist(tom_dis), method = 'average')
plot(geneTree, xlab = '', sub = '', main = 'Gene clustering on TOM-based dissimilarity',
     labels = FALSE, hang = 0.04)

#ʹö̬ھģ
minModuleSize <- 50  #ģĿ
dynamicMods <- cutreeDynamic(dendro = geneTree, distM = tom_dis,
                             deepSplit = 2, pamRespectsDendro = FALSE, minClusterSize = minModuleSize)

table(dynamicMods)

#ģɫָ
dynamicColors <- labels2colors(dynamicMods)
table(dynamicColors)

pdf("R02_ξ.pdf")
plotDendroAndColors(geneTree, dynamicColors, 'Dynamic Tree Cut',
                    dendroLabels = FALSE, addGuide = TRUE, hang = 0.03, guideHang = 0.05,
                    main = 'Gene dendrogram and module colors')
dev.off()
#͹ͼ
plot_sim <- -(1-tom_sim)
#plot_sim <- log(tom_sim)
diag(plot_sim) <- NA
nSelect = 400 
set.seed(10); 
select = sample(ngenes, size = nSelect); 
selectTOM = tom_dis[select, select]; 
selectTree = hclust(as.dist(selectTOM), method = "average") 
selectColors = dynamicColors[select];
dynamicColors = labels2colors(dynamicMods)
#sizeGrWindow(9,9) 
pdf("R03_Network_heatmap_plot_select400.pdf")
power <- 2
plotDiss = selectTOM^power; 
TOMplot(plotDiss, selectTree, selectColors,
        main = 'Network heatmap plot, selected genes')
dev.off()

#######################################
###step5ģӦþ
#ģ
#ģ򣨵һɷ֣
MEList <- moduleEigengenes(gene, colors = dynamicColors)
MEs <- MEList$eigengenes
head(MEs)[1:6]

#ģ
write.table(MEs, 'moduleEigengenes.txt', sep = '\t', col.names = NA, quote = FALSE)


#ģĽһ
#ͨģģԣģƶ
ME_cor <- cor(MEs)
ME_cor[1:6,1:6]

#ƾ۲
pdf("R04_۲.pdf")
METree <- hclust(as.dist(1-ME_cor), method = 'average')
plot(METree, main = 'Clustering of module eigengenes', xlab = '', sub = '')

#̽Է۲ģ
#height ֵɴģȣȷһʵֵΪи߶
#ԱΪȣƶȣģϲṩ
abline(h = 0.25, col = 'blue')
abline(h = 0.3, col = 'red')
dev.off()
#ģͼ
pdf("R05_ģֵͼ.pdf")
plotEigengeneNetworks(MEs, '', cex.lab = 0.8, xLabelsAngle= 90,
                      marDendro = c(0, 4, 1, 2), marHeatmap = c(3, 4, 1, 2))
dev.off()

#ģϲ 0.25 Ϊϲֵи߶ȣڴ˸߶µģ齫ϲ
#Ϊس̶ȸ 0.75 ģ齫ϲһ
merge_module <- mergeCloseModules(gene, dynamicColors, cutHeight = 0.35, verbose = 3)
mergedColors <- merge_module$colors
table(mergedColors)

#ģ

pdf("R06_ģͼϲ.pdf")
plotDendroAndColors(geneTree, cbind(dynamicColors, mergedColors), c('Dynamic Tree Cut', 'Merged dynamic'),
                    dendroLabels = FALSE, addGuide = TRUE, hang = 0.03, guideHang = 0.05)
dev.off()

#######################################
###step6:ģ͵Ĺ
#
trait <- read.delim('traits.txt', row.names = 1, check.names = FALSE)
trait_1 <- data.frame(trait)
#ʹһϵĹģĽ
module <- merge_module$newMEs

#߻򹲱ģٴ͵Է
moduleTraitCor <- cor(module, trait, use = 'p')
moduleTraitCor[1:4,1:4]  #ؾ

#ϵ p ֵ
moduleTraitPvalue <- corPvalueStudent(moduleTraitCor, nrow(module))

#ϵ p ֵ
#write.table(moduleTraitCor, 'moduleTraitCor.txt', sep = '\t', col.names = NA, quote = FALSE)
#write.table(moduleTraitPvalue, 'moduleTraitPvalue.txt', sep = '\t', col.names = NA, quote = FALSE)

#ͼ
pdf("R07_ģͼ.pdf")
textMatrix <- paste(signif(moduleTraitCor, 2), '\n(', signif(moduleTraitPvalue, 1), ')', sep = '')
dim(textMatrix) <- dim(moduleTraitCor)

par(mar = c(5, 10, 3, 3))

labeledHeatmap(Matrix = moduleTraitCor, main = paste('Module-trait relationships'),
               xLabels = names(trait), yLabels = names(module), ySymbols = names(module),
               colorLabels = FALSE, colors = greenWhiteRed(50), cex.text = 0.6, zlim = c(-1,1),
               textMatrix = textMatrix, setStdMargins = FALSE)
dev.off()

#######################################
###step7:ģڻ򼰱ȡ
#ģĶӦϵб
gene <- data.frame(gene)
gene_module <- data.frame(gene_name = colnames(gene), module = mergedColors, stringsAsFactors = FALSE)
head(gene_module)               

#brownģڵĻ
gene_module_select <- subset(gene_module, module == 'purple')$gene_name
head(gene_module_select)
gene_module_select
write.table(gene_module_select, "gene_module_select_purple.txt")
#blackģڻڸеıֵ󣨻ֵһӼ
gene_select <- t(gene[,gene_module_select])
head(gene_select)

#blackģڻĹƶȣ TOM ȡӼ
tom_select <- tom_sim[gene_module_select,gene_module_select]

#######################################
###step8:ѰģйؼӼ
#ѡ black ģڵĻ
gene_blue <- gene[ ,gene_module_select]
gene_brown <- gene[ ,gene_module_select]
gene_purple <- gene[ ,gene_module_select]
#ģԱȣmodule membership
#ֵӦģԣ˻ȫеλ
geneModuleMembership <- signedKME(gene_purple, module['MEpurple'], outputColumnName = 'MM')
head(geneModuleMembership)
MMPvalue <- as.data.frame(corPvalueStudent(as.matrix(geneModuleMembership), nrow(module)))
MMPvalue

#ֵٴ͵Է
head(trait)
geneTraitSignificance <- as.data.frame(cor(gene_purple, trait['Volume'], use = 'p'))
dim(geneTraitSignificance)

GSPvalue <- as.data.frame(corPvalueStudent(as.matrix(geneTraitSignificance), nrow(trait)))
dim(GSPvalue)

#ѡp<0.01 black ģԱȣMM>=0.8 TNM ͸߶أr>=0.8Ļ
geneModuleMembership <- abs(geneModuleMembership)
geneTraitSignificance <- abs(geneTraitSignificance)
geneModuleMembership[geneModuleMembership<0.6 | MMPvalue>0.01] = 0
geneTraitSignificance[geneTraitSignificance<0.6 | MMPvalue>0.01] = 0
select <- cbind(geneModuleMembership, geneTraitSignificance)
select <- subset(select, abs(geneModuleMembership)>=0.6 & abs(geneTraitSignificance)>=0.6)
head(select)
dim(select)

write.csv(select, "hubgene_brown_TD_0.6.csv")
write.csv(select, "hubgene_brown_LD_0.6.csv")
write.csv(select, "hubgene_brown_Weight_0.6.csv")
write.csv(select, "hubgene_brown_Volume_0.6.csv")

#ѡ TNM ڵɢͼ
dir.create('blue_LD_cor', recursive = TRUE)

for (i in rownames(select)) {
  png(paste('blue_Volume_cor/', i, '-Volume.png', sep = ''),
      width = 4, height = 4, res = 400, units = 'in', type = 'cairo')
  plot(trait[ ,'Volume'], gene[ ,i], xlab = 'Volume', ylab = i,
       main = paste('MM_blue = ', select[i,'MMblue'], '\ncor_Volume = ', select[i,'Volume']), cex = 0.8, pch = 20)
  fit <- lm(gene[ ,i]~trait[ ,'Volume'])
  lines(trait[ ,'Volume'], fitted(fit))
  dev.off()
}

#ѡ TOM 
plotNetworkHeatmap(gene,
                   plotGenes = rownames(select),
                   networkType = 'unsigned',
                   useTOM = TRUE,
                   power = powers,
                   main = 'unsigned correlations')

###ӻ
#ģıбͽڵбɵ cytoscape ͼ
#УߵȨΪ TOM еֵ¼˻乲
dir.create('cytoscape', recursive = TRUE)
dir.create('cytoscape2', recursive = TRUE)

for (mod in 1:nrow(table(mergedColors))) {
  modules <- names(table(mergedColors))[mod]
  probes <- colnames(gene)
  inModule <- (mergedColors == modules)
  modProbes <- probes[inModule]
  modGenes <- modProbes
  modtom_sim <- tom_sim[inModule, inModule]
  dimnames(modtom_sim) <- list(modProbes, modProbes)
  outEdge <- paste('cytoscape/', modules, '.edge_list.txt',sep = '')
  outNode <- paste('cytoscape/', modules, '.node_list.txt', sep = '')
  exportNetworkToCytoscape(modtom_sim,
                           edgeFile = outEdge,
                           nodeFile = outNode,
                           weighted = TRUE,
                           threshold = 0.3,  #òɿı˵Ȩصı
                           nodeNames = modProbes,
                           altNodeNames = modGenes,
                           nodeAttr = mergedColors[inModule])
}



