getwd()

library(pheatmap)
install.packages("gplots")
library(gplots)
exp <- read.table("Result_reseq_DEGs_id_FPKM.txt", sep = "\t", header = T, row.names = 1)
exp
#bk = unique(c(seq(-2, 2, length = 100)))

pheatmap(exp, scale = "row", 
         cexCol = 1,
         cluster_cols = F, cluster_rows = T,
         border = F, angle_col = "45",
         gaps_col = c(2, 4, 6),
         #gaps_row = c(8, 18, 37, 50, 79),
         cellwidth = 20,
         cellheight = 8,
         display_numbers = T,
         color = colorRampPalette(c("navy", "white", "red"))(100),
         filename = "heatmap_dalizaoshu_name.pdf")

annotation_row = data.frame(ClassGene = factor(paste0("Cluster", cutree(clust$tree_row, 10))))
rownames(annotation_row) = rownames(exp)
#annotation_col = annotation_col

pheatmap(log(exp + 1), #breaks = bk, 
         scale = "row", 
         cluster_cols = F, cluster_rows = T,
         clustering_distance_rows = "correlation",
         display_numbers = T,
         show_rownames = T,
         #cutree_cols = 4,
         gaps_col = c(2, 4, 6),
         #cutree_rows = 6,
         show_rownames = F,
         cellwidth = 20,
         cellheight = 8,
         border = F,
         angle_col = "45",
         #annotation_col = annotation_col,
         #annotation_row = annotation_row,
         color = colorRampPalette(c("navy", "white", "red"))(100),
         filename = "heatmap_dalizaoshu_FPKM_name.pdf")
